## dotnet9 9.0.100

=== runtime/src/native/libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

include(CheckCCompilerFlag)

project(CoreFX C)

include(../../../eng/native/configurepaths.cmake)
include(${CLR_ENG_NATIVE_DIR}/configurecompiler.cmake)

include_directories(${CLR_SRC_NATIVE_DIR})

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if (STATIC_LIBS_ONLY)
    # Suppress exporting of the PAL APIs
    add_definitions(-DPALEXPORT=EXTERN_C)

    set(GEN_SHARED_LIB 0)
    set(STATIC_LIB_DESTINATION lib)
else ()
    set(GEN_SHARED_LIB 1)
    set(STATIC_LIB_DESTINATION .)
endif ()

if (CLR_CMAKE_TARGET_UNIX OR CLR_CMAKE_TARGET_BROWSER OR CLR_CMAKE_TARGET_WASI)
    set(CMAKE_MACOSX_RPATH ON)
    if (CLR_CMAKE_TARGET_MACCATALYST OR CLR_CMAKE_TARGET_IOS OR CLR_CMAKE_TARGET_TVOS)
        set(CMAKE_BUILD_WITH_INSTALL_NAME_DIR ON)
        set(CMAKE_INSTALL_NAME_DIR "@rpath")
    endif ()

    set(CMAKE_INSTALL_PREFIX $ENV{__CMakeBinDir})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wno-declaration-after-statement")

    if (CLR_CMAKE_TARGET_BROWSER)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-pre-c11-compat")
    endif()

    add_compile_options(-I${CMAKE_CURRENT_SOURCE_DIR}/Common)
    add_compile_options(-I${CMAKE_CURRENT_BINARY_DIR}/Common)

    if (CLR_CMAKE_TARGET_BROWSER OR CLR_CMAKE_TARGET_WASI)
        set(GEN_SHARED_LIB 0)
        set(STATIC_LIB_DESTINATION .)
    endif ()

    if (CLR_CMAKE_TARGET_WASI)
        set(HOST_WASI 1)
        add_compile_options(-I${CLR_REPO_ROOT_DIR}/src/mono/wasi/include/)
        add_compile_options(-I${CLR_REPO_ROOT_DIR}/src/mono/wasi/libs-include/)
        add_compile_options(-Wno-unused-variable)
        add_compile_options(-Wno-unused-parameter)
        add_compile_options(-Wno-gnu-statement-expression)
        add_compile_options(-DHOST_WASI)
        add_compile_options(-D_WASI_EMULATED_PROCESS_CLOCKS)
        add_compile_options(-D_WASI_EMULATED_SIGNAL)
        add_compile_options(-D_WASI_EMULATED_MMAN)
        # keep in sync with src\mono\wasi\build\WasiApp.targets
        # keep in sync with src\mono\wasi\wasi.proj
        add_link_options(-Wl,-z,stack-size=1048576,--initial-memory=5242880,--max-memory=52428800,-lwasi-emulated-process-clocks,-lwasi-emulated-signal,-lwasi-emulated-mman)
    endif ()

    if (CLR_CMAKE_TARGET_ANDROID)
        if (CROSS_ROOTFS)
            include_directories(SYSTEM "${CROSS_ROOTFS}/usr/include")
        endif ()
    endif ()

    string(TOUPPER ${CMAKE_BUILD_TYPE} UPPERCASE_CMAKE_BUILD_TYPE)

    if (UPPERCASE_CMAKE_BUILD_TYPE STREQUAL DEBUG OR UPPERCASE_CMAKE_BUILD_TYPE STREQUAL CHECKED)
        if (UPPERCASE_CMAKE_BUILD_TYPE STREQUAL DEBUG)
            add_compile_options(-O0)
        elseif (UPPERCASE_CMAKE_BUILD_TYPE STREQUAL CHECKED)
            add_compile_options(-O2)
        endif ()

        add_definitions(-DDEBUG)
    elseif (UPPERCASE_CMAKE_BUILD_TYPE STREQUAL RELEASE)
        # Use O1 option when the clang version is smaller than 3.9
        # Otherwise use O3 option in release build
        if (CLR_CMAKE_TARGET_ARCH_ARMV7L AND DEFINED ENV{CROSSCOMPILE} AND CMAKE_C_COMPILER_VERSION VERSION_LESS 3.9)
            add_compile_options (-O1)
        else ()
            if(CLR_CMAKE_TARGET_ANDROID)
                # -O2 optimization generates faster/smaller code on Android
                # TODO: This duplicates the settings in eng/native/configureoptimization.cmake, we should unify it
                add_compile_options (-O2)
            else()
                add_compile_options (-O3)
            endif ()
        endif ()
    else ()
        message(FATAL_ERROR "Unknown build type. Set CMAKE_BUILD_TYPE to DEBUG or RELEASE.")
    endif ()

    if (CLR_CMAKE_TARGET_APPLE)
        add_definitions(-D__APPLE_USE_RFC_3542)
    endif ()

    if (CLR_CMAKE_TARGET_LINUX OR CLR_CMAKE_TARGET_HAIKU)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
    endif ()
else ()
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
    add_subdirectory(System.Globalization.Native)
endif ()

add_subdirectory(System.IO.Compression.Native)

if (CLR_CMAKE_TARGET_UNIX OR CLR_CMAKE_TARGET_BROWSER OR CLR_CMAKE_TARGET_WASI)
    include(configure.cmake)

    if (NOT CLR_CMAKE_TARGET_BROWSER AND NOT CLR_CMAKE_TARGET_WASI AND NOT CLR_CMAKE_TARGET_IOS AND NOT CLR_CMAKE_TARGET_TVOS)
        add_subdirectory(System.IO.Ports.Native)
    endif ()

    if (CMAKE_C_COMPILER_ID MATCHES "Clang")
        add_compile_options(-Weverything)
        add_compile_options(-Wno-format-nonliteral)
        add_compile_options(-Wno-disabled-macro-expansion)
        add_compile_options(-Wno-padded)
        add_compile_options(-Wno-empty-translation-unit)
        add_compile_options(-Wno-cast-align)
        add_compile_options(-Wno-typedef-redefinition)
        add_compile_options(-Wno-c11-extensions)
        add_compile_options(-Wno-pre-c11-compat) # fixes build on Debian
        add_compile_options(-Wno-unknown-warning-option) # unknown warning option '-Wno-pre-c11-compat'
        add_compile_options(-Wno-thread-safety-analysis)
        if (CLR_CMAKE_TARGET_BROWSER OR CLR_CMAKE_TARGET_WASI)
            add_compile_options(-Wno-unsafe-buffer-usage)
            add_compile_options(-Wno-cast-function-type-strict)
        endif ()
    endif ()

    add_subdirectory(System.Native)
    add_subdirectory(System.Globalization.Native)

    if (CLR_CMAKE_TARGET_BROWSER OR CLR_CMAKE_TARGET_WASI)
        # skip for now
    elseif (CLR_CMAKE_TARGET_MACCATALYST)
        add_subdirectory(System.Net.Security.Native)
        # System.Security.Cryptography.Native is intentionally disabled on iOS
        # it is only used for interacting with OpenSSL which isn't useful there
    elseif (CLR_CMAKE_TARGET_IOS)
        add_subdirectory(System.Net.Security.Native)
        # System.Security.Cryptography.Native is intentionally disabled on iOS
        # it is only used for interacting with OpenSSL which isn't useful there
    elseif (CLR_CMAKE_TARGET_TVOS)
        #add_subdirectory(System.Net.Security.Native) # no gssapi on tvOS, see https://developer.apple.com/documentation/gss
        # System.Security.Cryptography.Native is intentionally disabled on tvOS
        # it is only used for interacting with OpenSSL which isn't useful there
    elseif (CLR_CMAKE_TARGET_ANDROID AND NOT FORCE_ANDROID_OPENSSL)
        add_subdirectory(System.Security.Cryptography.Native.Android)
    elseif (FORCE_ANDROID_OPENSSL)
        add_subdirectory(System.Security.Cryptography.Native)
    else ()
        add_subdirectory(System.Net.Security.Native)
        add_subdirectory(System.Security.Cryptography.Native)
    endif ()

    if (CLR_CMAKE_TARGET_APPLE)
        add_subdirectory(System.Security.Cryptography.Native.Apple)
    endif ()
endif ()

=== sdk/src/Installer/finalizer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

# Create project named finalizer, this will generate Finalizer.vcxproj
project(Finalizer)

set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SUBSYSTEM:WINDOWS /ENTRY:wmainCRTStartup") 

# The WiX SDK is extracted from a NuGet package using an SDK .csproj (finalizer-build) that copies the "lib" and "inc" folders to a stable location.
# The defines below (values in ${}) are set in the finalizer.nativeproj.
# See: https://github.com/dotnet/arcade/tree/main/src/Microsoft.DotNet.CMake.Sdk#common-items
# Note: The directory paths use forward slashes because backslashes are escape characters.
include_directories(${ArtifactsDir}WixSdk/inc)
include_directories(${ArtifactsDir}obj)
link_directories(${ArtifactsDir}WixSdk/lib/${Platform})

add_compile_options(/MT)

# Microsoft.Security.SystemsADM.10086
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/W3>)
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/WX>)
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4018>) # 'expression' : signed/unsigned mismatch
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4055>) # 'conversion' : from data pointer 'type1' to function pointer 'type2'
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4146>) # unary minus operator applied to unsigned type, result still unsigned
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4242>) # 'identifier' : conversion from 'type1' to 'type2', possible loss of data
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4244>) # 'conversion' conversion from 'type1' to 'type2', possible loss of data
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4267>) # 'var' : conversion from 'size_t' to 'type', possible loss of data
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4302>) # 'conversion' : truncation from 'type 1' to 'type 2'
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4308>) # negative integral constant converted to unsigned type
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4509>) # nonstandard extension used: 'function' uses SEH and 'object' has destructor
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4510>) # 'class' : default constructor could not be generated
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4532>) # 'continue' : jump out of __finally/finally block has undefined behavior during termination handling
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4533>) # initialization of 'variable' is skipped by 'instruction'
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4610>) # object 'class' can never be instantiated - user-defined constructor required
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4611>) # interaction between 'function' and C++ object destruction is non-portable
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4700>) # uninitialized local variable 'name' used
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4701>) # Potentially uninitialized local variable 'name' used
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4703>) # Potentially uninitialized local pointer variable 'name' used
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4789>) # destination of memory copy is too small
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4995>) # 'function': name was marked as #pragma deprecated
add_compile_options($<$<COMPILE_LANGUAGE:C,CXX>:/we4996>) # 'function': was declared deprecated also 'std::'

add_executable(Finalizer 
  finalizer.cpp
  native.rc
)

# These are normally part of a .vcxproj in Visual Studio, but appears to be missing when CMAKE generates a .vcxproj for arm64.
target_link_libraries(Finalizer shell32.lib)
target_link_libraries(Finalizer advapi32.lib)
target_link_libraries(Finalizer version.lib)
target_link_libraries(Finalizer msi.lib)
target_link_libraries(Finalizer shlwapi.lib)

# Add WiX libraries
target_link_libraries(Finalizer wcautil.lib)
target_link_libraries(Finalizer dutil.lib)

install(TARGETS Finalizer)

=== runtime/src/native/corehost/hostmisc/CMakeLists.txt ===
# Licensed to the .NET Foundation under one or more agreements.
# The .NET Foundation licenses this file to you under the MIT license.

include(configure.cmake)

# CMake does not recommend using globbing since it messes with the freshness checks
set(SOURCES
    ${CMAKE_CURRENT_LIST_DIR}/trace.cpp
    ${CMAKE_CURRENT_LIST_DIR}/utils.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../fxr/fx_ver.cpp
)

set(HEADERS
    ${CMAKE_CURRENT_LIST_DIR}/trace.h
    ${CMAKE_CURRENT_LIST_DIR}/utils.h
    ${CMAKE_CURRENT_LIST_DIR}/pal.h
    ${CMAKE_CURRENT_LIST_DIR}/../error_codes.h
    ${CMAKE_CURRENT_LIST_DIR}/../fxr/fx_ver.h
)

if(CLR_CMAKE_TARGET_WIN32)
    list(APPEND SOURCES
        ${CMAKE_CURRENT_LIST_DIR}/pal.windows.cpp
        ${CMAKE_CURRENT_LIST_DIR}/longfile.windows.cpp)
    list(APPEND HEADERS
        ${CMAKE_CURRENT_LIST_DIR}/longfile.h)
else()
    list(APPEND SOURCES
        ${CMAKE_CURRENT_LIST_DIR}/pal.unix.cpp)
endif()

# hostmisc must be an "object library" as we want to build it once
# and embed the objects into static libraries we ship (like libnethost).
add_library(hostmisc OBJECT ${SOURCES})

target_include_directories(hostmisc PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CLR_SRC_NATIVE_DIR}
    ${CMAKE_CURRENT_LIST_DIR})

if (MSVC)
    target_sources(hostmisc PRIVATE ${HEADERS})
    target_link_libraries(hostmisc PUBLIC advapi32)
endif()

target_link_libraries(hostmisc PUBLIC
    ${CMAKE_DL_LIBS}
    $<$<BOOL:${PTHREAD_LIB}>:${PTHREAD_LIB}>)

if(CLR_CMAKE_TARGET_ARCH_ARM OR CLR_CMAKE_TARGET_ARCH_ARMV6)
    target_link_libraries(hostmisc PUBLIC
    $<$<BOOL:${ATOMIC_SUPPORT_LIB}>:${ATOMIC_SUPPORT_LIB}>)
endif()

=== runtime/src/native/corehost/nethost/CMakeLists.txt ===
# Licensed to the .NET Foundation under one or more agreements.
# The .NET Foundation licenses this file to you under the MIT license.

# CMake does not recommend using globbing since it messes with the freshness checks
set(SOURCES
    nethost.cpp
)

if(CLR_CMAKE_TARGET_WIN32)
    list(APPEND SOURCES
        Exports.def)
endif()

add_compile_definitions(
    EXPORT_SHARED_API
    FEATURE_LIBHOST
    NETHOST_EXPORT)

add_library(nethost SHARED ${SOURCES})
add_library(libnethost STATIC ${SOURCES})

add_version_info_to_target(nethost)
add_version_info_to_target(libnethost nethost)

target_include_directories(nethost PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(libnethost PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

# Copy static lib PDB to the project output directory
if (WIN32)
    set_target_properties(libnethost PROPERTIES
        COMPILE_PDB_NAME "libnethost"
        COMPILE_PDB_OUTPUT_DIRECTORY "$<TARGET_FILE_DIR:libnethost>"
    )
endif(WIN32)

target_link_libraries(nethost PRIVATE hostmisc fxr_resolver)
target_link_libraries(libnethost PRIVATE hostmisc fxr_resolver)
target_compile_definitions(nethost PRIVATE FEATURE_LIBHOST NETHOST_EXPORT)
target_compile_definitions(libnethost PRIVATE FEATURE_LIBHOST NETHOST_EXPORT)

set_target_properties(nethost PROPERTIES MACOSX_RPATH TRUE)
set_target_properties(libnethost PROPERTIES MACOSX_RPATH TRUE)
set_target_properties(libnethost PROPERTIES PREFIX "")

target_link_libraries (nethost PRIVATE ${CMAKE_DL_LIBS})
target_link_libraries (libnethost PUBLIC ${CMAKE_DL_LIBS})

install(FILES ../coreclr_delegates.h DESTINATION corehost)
install(FILES ../hostfxr.h DESTINATION corehost)
install(FILES nethost.h DESTINATION corehost)
install_with_stripped_symbols(nethost TARGETS corehost)

if (MSVC)
    # We ship libnethost.lib as a static library for external consumption, so
    # LTCG must be disabled to ensure that non-MSVC toolchains can work with it.

    set_target_properties(libnethost PROPERTIES INTERPROCEDURAL_OPTIMIZATION OFF)

    string(REPLACE "/LTCG" "" CMAKE_STATIC_LINKER_FLAGS_RELEASE ${CMAKE_STATIC_LINKER_FLAGS_RELEASE})
    string(REPLACE "/LTCG" "" CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO ${CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO})
endif()

# Only Windows creates a symbols file for static libs.
if (WIN32)
    install_with_stripped_symbols(libnethost TARGETS corehost)
else()
    install(TARGETS libnethost DESTINATION corehost)
endif(WIN32)

=== runtime/src/native/corehost/apphost/static/CMakeLists.txt ===
# Licensed to the .NET Foundation under one or more agreements.
# The .NET Foundation licenses this file to you under the MIT license.

project(singlefilehost)
set(DOTNET_PROJECT_NAME "singlefilehost")

# Add RPATH to the apphost binary that allows using local copies of shared libraries
# dotnet core depends on for special scenarios when system wide installation of such
# dependencies is not possible for some reason.
# This cannot be enabled for MacOS (Darwin) since its RPATH works in a different way,
# doesn't apply to libraries loaded via dlopen and most importantly, it is not transitive.
if (NOT CLR_CMAKE_TARGET_APPLE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
    set(CMAKE_INSTALL_RPATH "\$ORIGIN/netcoredeps")
endif()

include_directories(..)
include_directories(../..)
include_directories(../../hostmisc)
include_directories(../../json)
include_directories(${CLR_SRC_NATIVE_DIR}/libs/System.IO.Compression.Native)
include_directories(${CLR_SRC_NATIVE_DIR}/libs/Common)
include_directories(${CLR_ARTIFACTS_OBJ_DIR}) # Generated version files

add_subdirectory(../../hostmisc hostmisc)

configure_file(${CLR_SRC_NATIVE_DIR}/corehost/configure.h.in ${GENERATED_INCLUDE_DIR}/corehost/configure.h)
target_include_directories(hostmisc PUBLIC ${GENERATED_INCLUDE_DIR}/corehost)

if ((NOT DEFINED CLR_CMAKE_USE_SYSTEM_RAPIDJSON) OR (NOT CLR_CMAKE_USE_SYSTEM_RAPIDJSON))
    include_directories(${CLR_SRC_NATIVE_DIR}/external/)
endif()

set(SOURCES
    ../bundle_marker.cpp
    ./hostfxr_resolver.cpp
    ./hostpolicy_resolver.cpp
    ../../hostpolicy/static/coreclr_resolver.cpp
    ../../fxr_resolver.cpp
    ../../corehost.cpp
)

set(HEADERS
    ../bundle_marker.h
    ../../hostfxr_resolver.h
    ../../fxr_resolver.h
)

add_compile_definitions(NATIVE_LIBS_EMBEDDED)

include(../../fxr/files.cmake)
include(../../hostpolicy/files.cmake)
include(../../hostcommon/files.cmake)

if(MSVC)
    # Host components don't try to handle asynchronous exceptions
    set_property(DIRECTORY PROPERTY CLR_EH_OPTION /EHsc)
    set_property(TARGET hostmisc PROPERTY CLR_EH_OPTION /EHsc)
elseif (CMAKE_CXX_COMPILER_ID MATCHES GNU)
    # Prevents libc from calling pthread_cond_destroy on static objects in
    # dlopen()'ed library which we dlclose() in pal::unload_library.
    add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-fno-use-cxa-atexit>)
endif()

if(CLR_CMAKE_TARGET_WIN32)
    add_compile_definitions(UNICODE)
    list(APPEND SOURCES
        ../apphost.windows.cpp
        ${CLR_SRC_NATIVE_DIR}/libs/Common/delayloadhook_windows.cpp
    )

    list(APPEND HEADERS
        ../apphost.windows.h)
endif()

if(CLR_CMAKE_TARGET_WIN32)
    add_linker_flag("/DEF:${CMAKE_CURRENT_SOURCE_DIR}/singlefilehost.def")

else()
    if(CLR_CMAKE_TARGET_FREEBSD)
        set(DEF_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/singlefilehost_freebsdexports.src)
    else()
        set(DEF_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/singlefilehost_unixexports.src)
    endif()

    set(EXPORTS_FILE ${CMAKE_CURRENT_BINARY_DIR}/singlefilehost.exports)
    generate_exports_file(${DEF_SOURCES} ${EXPORTS_FILE})

    set_exports_linker_option(${EXPORTS_FILE})
endif()

add_executable(singlefilehost ${SOURCES})

add_sanitizer_runtime_support(singlefilehost)

if(NOT CLR_CMAKE_TARGET_WIN32)
    disable_pax_mprotect(singlefilehost)
endif()

install_with_stripped_symbols(singlefilehost TARGETS corehost COMPONENT runtime)

include(configure.cmake)

if(CLR_CMAKE_HOST_UNIX)
    add_custom_target(singlefilehost_exports DEPENDS ${EXPORTS_FILE})
    add_dependencies(singlefilehost singlefilehost_exports)

    set_property(TARGET singlefilehost APPEND_STRING PROPERTY LINK_FLAGS ${EXPORTS_LINKER_OPTION})
    set_property(TARGET singlefilehost APPEND_STRING PROPERTY LINK_DEPENDS ${EXPORTS_FILE})
endif()

add_definitions(-DFEATURE_APPHOST=1)
add_definitions(-DFEATURE_STATIC_HOST=1)

if(CLR_CMAKE_TARGET_WIN32)
    # Disable manifest generation into the file .exe on Windows
    add_linker_flag("/MANIFEST:NO")

    # Enable CET-compatibility
    if (CLR_CMAKE_HOST_ARCH_AMD64)
        add_linker_flag("/CETCOMPAT")
    endif()

    # Incremental linking results in the linker inserting extra padding and routing function calls via thunks that can break the
    # invariants (e.g. size of region between Jit_PatchedCodeLast-Jit_PatchCodeStart needs to fit in a page).
    add_linker_flag("/INCREMENTAL:NO")

    # Delay load libraries required for WinRT as that is not supported on all platforms
    add_linker_flag("/DELAYLOAD:api-ms-win-core-winrt-l1-1-0.dll")

    # Delay load version.dll so that we can specify how to search when loading it as it is not part of Windows' known DLLs
    add_linker_flag("/DELAYLOAD:version.dll")
endif()

if(CLR_CMAKE_TARGET_WIN32)
    set(NATIVE_LIBS
        coreclr_static

        System.Globalization.Native-Static
        System.IO.Compression.Native-Static

        kernel32.lib
        advapi32.lib
        ole32.lib
        oleaut32.lib
        uuid.lib
        user32.lib
        version.lib
        shlwapi.lib
        shell32.lib
        bcrypt.lib
        RuntimeObject.lib
        delayimp.lib
    )

    set(RUNTIMEINFO_LIB runtimeinfo)

else()
    if(CLR_CMAKE_HOST_OSX OR (CLR_CMAKE_HOST_LINUX AND NOT CLR_CMAKE_HOST_UNIX_X86 AND NOT CLR_CMAKE_HOST_ANDROID))
        LIST(APPEND NATIVE_LIBS createdump_static)
    endif()

    LIST(APPEND NATIVE_LIBS
        coreclr_static

        System.Globalization.Native-Static
        System.IO.Compression.Native-Static
        System.Net.Security.Native-Static
        System.Native-Static
        System.Security.Cryptography.Native.OpenSsl-Static

        palrt
        coreclrpal_dac
        corguids
        dbgutil
        eventprovider
        nativeresourcestring
    )

    # additional requirements for System.IO.Compression.Native
    include(${CLR_SRC_NATIVE_DIR}/libs/System.IO.Compression.Native/extra_libs.cmake)
    append_extra_compression_libs(NATIVE_LIBS)

    if (NOT CLR_CMAKE_TARGET_TVOS AND NOT CLR_CMAKE_HOST_ANDROID) # no gssapi on tvOS, see https://developer.apple.com/documentation/gss
        # Additional requirements for System.Net.Security.Native
        include(${CLR_SRC_NATIVE_DIR}/libs/System.Net.Security.Native/extra_libs.cmake)
        append_extra_security_libs(NATIVE_LIBS)
    endif()

    # Additional requirements for System.Native
    include(${CLR_SRC_NATIVE_DIR}/libs/System.Native/extra_libs.cmake)
    append_extra_system_libs(NATIVE_LIBS)

    if(NOT CLR_CMAKE_TARGET_MACCATALYST AND NOT CLR_CMAKE_TARGET_IOS AND NOT CLR_CMAKE_TARGET_TVOS AND NOT CLR_CMAKE_HOST_ANDROID)
        # Additional requirements for System.Security.Cryptography.Native.OpenSsl
        include(${CLR_SRC_NATIVE_DIR}/libs/System.Security.Cryptography.Native/extra_libs.cmake)
        append_extra_cryptography_libs(NATIVE_LIBS)
    endif()

    set(RUNTIMEINFO_LIB runtimeinfo)

endif()

if(CLR_CMAKE_TARGET_APPLE)
    LIST(APPEND NATIVE_LIBS
        System.Security.Cryptography.Native.Apple-Static
    )

    # Additional requirements for System.Security.Cryptography.Native.Apple
    include(${CLR_SRC_NATIVE_DIR}/libs/System.Security.Cryptography.Native.Apple/extra_libs.cmake)
    append_extra_cryptography_apple_libs(NATIVE_LIBS)
endif()

#
# Additional requirements for coreclr
#
if(CLR_CMAKE_TARGET_APPLE)
   find_library(COREFOUNDATION CoreFoundation)
   find_library(CORESERVICES CoreServices)
   find_library(SECURITY Security)
   find_library(SYSTEM System)

   LIST(APPEND NATIVE_LIBS
     ${COREFOUNDATION}
     ${CORESERVICES}
     ${SECURITY}
     ${SYSTEM}
   )
elseif(CLR_CMAKE_TARGET_NETBSD)
     find_library(KVM kvm)

     LIST(APPEND NATIVE_LIBS
       ${KVM}
     )
elseif (CLR_CMAKE_TARGET_SUNOS)
     LIST(APPEND NATIVE_LIBS
         socket
     )
elseif (CLR_CMAKE_TARGET_HAIKU)
     LIST(APPEND NATIVE_LIBS
         network
     )
endif(CLR_CMAKE_TARGET_APPLE)

# On *BSD, we always use the libunwind that's part of the OS
if(CLR_CMAKE_TARGET_FREEBSD)
  set(CLR_CMAKE_USE_SYSTEM_LIBUNWIND 1)
endif()

if(CLR_CMAKE_USE_SYSTEM_LIBUNWIND AND NOT CLR_CMAKE_TARGET_APPLE)
    find_unwind_libs(UNWIND_LIBS)

    LIST(APPEND NATIVE_LIBS
      ${UNWIND_LIBS}
    )
endif()

if(CLR_CMAKE_TARGET_LINUX OR CLR_CMAKE_TARGET_FREEBSD OR CLR_CMAKE_TARGET_NETBSD OR CLR_CMAKE_TARGET_SUNOS)
    # These options are used to force every object to be included even if it's unused.
    set(START_WHOLE_ARCHIVE -Wl,--whole-archive)
    set(END_WHOLE_ARCHIVE -Wl,--no-whole-archive)
endif(CLR_CMAKE_TARGET_LINUX OR CLR_CMAKE_TARGET_FREEBSD OR CLR_CMAKE_TARGET_NETBSD OR CLR_CMAKE_TARGET_SUNOS)

if(CLR_CMAKE_TARGET_LINUX AND CLR_CMAKE_TARGET_ARCH_RISCV64)
    add_linker_flag(-Wl,-z,notext)
endif()

if(CLR_CMAKE_TARGET_APPLE)
    # These options are used to force every object to be included even if it's unused.
    set(START_WHOLE_ARCHIVE -force_load)
    set(END_WHOLE_ARCHIVE )
endif(CLR_CMAKE_TARGET_APPLE)

set_property(TARGET singlefilehost PROPERTY ENABLE_EXPORTS 1)

target_link_libraries(
    singlefilehost
    PRIVATE
    ${NATIVE_LIBS}

    ${START_WHOLE_ARCHIVE}
    ${RUNTIMEINFO_LIB}
    ${END_WHOLE_ARCHIVE}
)

target_link_libraries(singlefilehost PRIVATE hostmisc)

add_sanitizer_runtime_support(singlefilehost)

=== runtime/src/native/corehost/test/mockhostfxr/CMakeLists.txt ===
# Licensed to the .NET Foundation under one or more agreements.
# The .NET Foundation licenses this file to you under the MIT license.

add_library(mockhostfxr_2_2 SHARED mockhostfxr.cpp)
add_library(mockhostfxr_5_0 SHARED mockhostfxr.cpp)

target_link_libraries(mockhostfxr_2_2 PRIVATE libhostcommon)
target_link_libraries(mockhostfxr_5_0 PRIVATE libhostcommon)

target_compile_definitions(mockhostfxr_2_2 PRIVATE MOCKHOSTFXR_2_2 EXPORT_SHARED_API)
target_compile_definitions(mockhostfxr_5_0 PRIVATE MOCKHOSTFXR_5_0 EXPORT_SHARED_API)

install_with_stripped_symbols(mockhostfxr_2_2 TARGETS corehost_test)
install_with_stripped_symbols(mockhostfxr_5_0 TARGETS corehost_test)

## dotnet9 9.0.100-9.0.0~rc2

=== debian/changelog ===
dotnet9 (9.0.100-9.0.0~rc2-0ubuntu1) oracular; urgency=medium

   * New upstream release (LP: #2083883)
   * dropped d/p/0003-use-system-brotli-on-unix-non-portable-builds.patch and
     d/p/0004-use-consistent-shift-instruction.patch:
     Included with new upstream release.
   * d/rules: Fixed missing definition of substitution variable ${libicu:Depends}
     (used to be defined in d/substvars file, but buildlog indicated that this is
     not used by dh_gencontrol).
   * d/t/build-time-tests/test.py: Fixed falsely reported test failure due to new
                                   'dotnet run' CLI design.
   * d/control:
     - Moved dotnet-sdk-aot-9.0 to Recommends from Suggests
       for dotnet9 virtual package.
     - Added dotnet-sdk-dbg-9.0, dotnet-runtime-dbg-9.0,
       aspnetcore-runtime-dbg-9.0 to Suggests for dotnet9 virtual package.
     - Fixed descriptions with invalid control statements
       (lines containing a space, a full stop and some more characters)
       to comply with Section 5.6.13 in the Debian Policy Manual.
   * d/copyright:
     - Contained full Apache-2.0 and LGPL-2.1 license text; referred to
       /usr/share/common-licenses instead.
     - Removed references to files no longer present in new upstream release
       sources.
   * d/aspnetcore-runtime-9.0.docs, d/dotnet-sdk-9.0.docs: Included
     src/razor/NOTICE.txt in package to comply with Apache-2.0
     paragraph 4 section (d).
   * d/source/lintian-overrides:
     - Adjust source-is-missing and source-contains-prebuilt-javascript-object
       overrides due to file changes caused by the new upstream release.
     - Add hyphen-in-upstream-part-of-debian-changelog-version override:
       Canonical Specification FO127 mandates a hyphen in the upstream part of
       the Debian changelog version.
   * d/aspnetcore-targeting-pack-9.0.lintian-overrides,
     d/dotnet-sdk-9.0.lintian-overrides,
     d/dotnet-sdk-dbg-9.0.lintian-overrides,
     d/dotnet-targeting-pack-9.0.lintian-overrides:
     Ignore repeated-path-segment warnings, as these repetitions are intended.
   * d/aspnetcore-targeting-pack-9.0.lintian-overrides:
     ignore package-has-long-file-name warnings

 -- Dominik Viererbe <dominik.viererbe@canonical.com>  Mon, 07 Oct 2024 13:42:57 +0000

dotnet9 (9.0.100-9.0.0~rc1-0ubuntu2) oracular; urgency=medium

  * d/rules: tweaks for s390x and ppc64el builds.
    - Explicit usage of the --with-sdk build argument when bootstrapping.
    - Added the --use-mono-runtime flag based on the DOTNET_USE_MONO_RUNTIME
      variable.
    - Conditional dh_gencontrol override for dotnet-sdk-aot-9.0 binary package
      based on the DOTNET_BUILD_AOT_BINARY_PACKAGE variable.
    - Added the --with-system-libs build argument based on the several
      DOTNET_USE_SYSTEM_* library specifier variables.
  * d/eng/dotnet-pkg-info.mk: defined the DOTNET_BUILD_AOT_BINARY_PACKAGE,
    DOTNET_USE_MONO_RUNTIME, and DOTNET_USE_SYSTEM_* variables.
  * d/control: tweaks for s390x and ppc64el builds.
    - Added dh-exec, libbrotli-dev, and rapidjson-dev as build dependencies.
    - The dotnet9 package now only suggests dotnet-sdk-aot-9.0.
    - Changed the dotnet-sdk-aot-9.0 binary package architectures to amd64
      and arm64 only.
  * d/dotnet-sdk-9.0.install: added dh-exec to filter out files not present in
    certain architectures and marked the file as executable.
  * d/t/control: added missing development libraries for the nativeaot-sb test
    and replaced packages provided by this source package with @.
  * d/t/regular-tests/bundled-libunwind/test.json: skipping test when on
    amd64, which no longer bundles libunwind.
  * d/p/0003-use-system-brotli-on-unix-non-portable-builds.patch: fixed
    nativeaot-sb autopkgtest by integrating upstream patch making NativeAOT
    use the system brotli library.
  * d/p/0004-use-consistent-shift-instruction.patch: fixed 'dotnet build'
    throwing System.OutOfMemoryException on stage 2 .NET 9 RC1 build.

 -- Mateus Rodrigues de Morais <mateus.morais@canonical.com>  Thu, 19 Sep 2024 15:54:25 -0300

dotnet9 (9.0.100-9.0.0~rc1-0ubuntu1) oracular; urgency=medium

  * Initial release (LP: #2079031)

 -- Dominik Viererbe <dominik.viererbe@canonical.com>  Fri, 06 Sep 2024 17:57:18 +0300

=== debian/control ===
Source: dotnet9
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: bash-completion,
               clang,
               cmake,
               debhelper-compat (= 13),
               dh-exec,
               dotnet-sdk-9.0,
               dotnet-sdk-9.0-source-built-artifacts,
               git,
               libicu-dev,
               libkrb5-dev,
               liblttng-ust-dev,
               libbrotli-dev,
               libssl-dev,
               libunwind-dev,
               lld,
               llvm,
               locales-all,
               python3,
               rapidjson-dev,
               tree,
               zlib1g-dev
Standards-Version: 4.6.2
Rules-Requires-Root: binary-targets
Homepage: https://dot.net

Package: dotnet9
Architecture: amd64 arm64 s390x ppc64el
Depends: dotnet-sdk-9.0, ${misc:Depends}, ${shlibs:Depends}
Recommends: dotnet-sdk-aot-9.0 [amd64 arm64]
Suggests: dotnet-sdk-dbg-9.0, dotnet-runtime-dbg-9.0, aspnetcore-runtime-dbg-9.0
Breaks: dotnet6 (<< 6.0.111~)
Description: .NET CLI tools and runtime
 The .NET platform is a fast, lightweight and modular, enabling the creation of
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications, and micro-services.
 .
 The .NET platform contains a runtime conforming to .NET Standards, a set of
 framework libraries, an SDK containing compilers, and a 'dotnet'
 CLI application to drive everything.

Package: dotnet-host-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: dotnet-host, dotnet-host-7.0, dotnet-host-8.0
Replaces: dotnet-host, dotnet-host-7.0, dotnet-host-8.0
Provides: dotnet-host, dotnet-host-7.0, dotnet-host-8.0
Description: .NET host command line
 The .NET host is a command line program that runs a standalone .NET
 application or launches the SDK.
 .
 The .NET platform is a fast, lightweight and modular, enabling the creation of
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications, and micro-services.

Package: dotnet-hostfxr-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: dotnet-host-9.0, ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-hostfxr-6.0 (<< 6.0.111~)
Description: .NET host resolver
 The .NET host resolver contains the logic to resolve and select
 the right version of the .NET SDK or runtime to use.
 .
 The .NET platform is a fast, lightweight and modular, enabling the creation of
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications, and micro-services.

Package: dotnet-runtime-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: dotnet-hostfxr-9.0,
         ${libicu:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: dotnet-runtime-6.0 (<< 6.0.111~)
Description: .NET runtime
 The .NET runtime contains everything needed to run .NET applications.
 It includes a high performance Virtual Machine as well as the framework
 libraries used by .NET applications.
 .
 The .NET platform is a fast, lightweight and modular, enabling the creation of
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications, and micro-services.

Package: aspnetcore-runtime-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: dotnet-runtime-9.0, ${misc:Depends}, ${shlibs:Depends}
Breaks: aspnetcore-runtime-6.0 (<< 6.0.111~)
Description: ASP.NET Core runtime
 The ASP.NET Core runtime contains everything needed to run .NET
 web applications. It includes a high performance Virtual Machine as
 well as the framework libraries used by .NET applications.
 .
 ASP.NET Core is a fast, lightweight and modular platform for creating
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications, and micro-services.

Package: dotnet-templates-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: dotnet-host-9.0, ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-templates-6.0 (<< 6.0.111~)
Description: .NET 9.0 templates
 This package contains templates used by the .NET SDK.
 .
 The .NET platform is a fast, lightweight and modular, enabling the creation of
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications, and micro-services.

Package: dotnet-sdk-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: aspnetcore-runtime-9.0,
         aspnetcore-targeting-pack-9.0,
         dotnet-apphost-pack-9.0,
         dotnet-runtime-9.0,
         dotnet-targeting-pack-9.0,
         dotnet-templates-9.0,
         netstandard-targeting-pack-2.1-9.0,
         ca-certificates,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: dotnet-sdk-6.0 (<< 6.0.111~)
Description: .NET 9.0 Software Development Kit
 The .NET SDK is a collection of command line applications to
 create, build, publish, and run .NET applications.
 .
 The .NET platform is a fast, lightweight and modular, enabling the creation of
 cross platform applications that work on GNU/Linux, macOS and Windows.
 .
 It particularly focuses on creating console applications, web
 applications, and micro-services.

Package: dotnet-sdk-9.0-source-built-artifacts
Architecture: amd64 arm64 s390x ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Internal package for building the .NET 9.0 Software Development Kit
 The .NET source-built archive is a collection of packages needed
 to build the .NET SDK itself.
 .
 These are not meant for general use.

Package: dotnet-sdk-aot-9.0
Architecture: amd64 arm64
Depends: dotnet-sdk-9.0, ${misc:Depends}, ${shlibs:Depends}
Description: .NET platform NativeAOT components.
 This package provides the SDK components for platform NativeAOT.

Package: dotnet-targeting-pack-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-targeting-pack-6.0 (<< 6.0.111~)
Description: Internal - targeting pack for Microsoft.NETCore.App 9.0
 This package provides a targeting pack for Microsoft.NETCore.App 9.0
 that allows developers to compile against and target Microsoft.NETCore.App 9.0
 applications using the .NET SDK. This are not meant for general use.

Package: netstandard-targeting-pack-2.1-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: netstandard-targeting-pack-2.1, netstandard-targeting-pack-2.1-7.0, netstandard-targeting-pack-2.1-8.0
Replaces: netstandard-targeting-pack-2.1, netstandard-targeting-pack-2.1-7.0, netstandard-targeting-pack-2.1-8.0
Provides: netstandard-targeting-pack-2.1, netstandard-targeting-pack-2.1-7.0, netstandard-targeting-pack-2.1-8.0
Description: Internal - targeting pack for NETStandard.Library 2.1
 This package provides a targeting pack for NETStandard.Library 2.1
 that allows developers to compile against and target NETStandard.Library 2.1
 applications using the .NET SDK.
 This are not meant for general use.

Package: aspnetcore-targeting-pack-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: aspnetcore-targeting-pack-6.0 (<< 6.0.111~)
Description: Internal - targeting pack for Microsoft.AspNetCore.App 9.0
 This package provides a targeting pack for Microsoft.AspNetCore.App 9.0
 that allows developers to compile against and target
 Microsoft.AspNetCore.App 9.0 applications using the .NET SDK.
 This are not meant for general use.

Package: dotnet-apphost-pack-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dotnet-apphost-pack-6.0 (<< 6.0.111~)
Description: Internal - targeting pack for Microsoft.NETCore.App 9.0
 This package provides a targeting pack for Microsoft.NETCore.App 9.0
 that allows developers to compile against and target Microsoft.NETCore.App 9.0
 applications using the .NET SDK. This not meant for general use.

Package: aspnetcore-runtime-dbg-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: aspnetcore-runtime-9.0, ${misc:Depends}, ${shlibs:Depends}
Description: ASP.NET Runtime debug symbols.
 This package provides the PDB debug symbols for Microsoft.AspNetCore.App 9.0.

Package: dotnet-runtime-dbg-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: dotnet-runtime-9.0, ${misc:Depends}, ${shlibs:Depends}
Description: .NET Runtime debug symbols.
 This package provides the PDB debug symbols for Microsoft.NETCore.App 9.0.

Package: dotnet-sdk-dbg-9.0
Architecture: amd64 arm64 s390x ppc64el
Depends: dotnet-sdk-9.0, ${misc:Depends}, ${shlibs:Depends}
Description: .NET SDK debug symbols.
 This package provides the PDB debug symbols for the .NET 9.0 SDK.

=== debian/rules ===
#!/usr/bin/make -f

SHELL = /usr/bin/bash

# .NET will create by default the directories ~/.dotnet and ~/.nuget, but
# sbuild will fail the build if anything is written to the default home directory.
# See https://github.com/dotnet/source-build/issues/2767
export HOME=$(shell mktemp --directory)

export DOTNET_BIN = /usr/bin/dotnet
export DOTNET_ROOT_DIR = /usr/lib/dotnet
export DOTNET_SYSCONF_DIR = /etc/dotnet
DEST_DIR = $(CURDIR)/debian/tmp

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include $(CURDIR)/debian/eng/dotnet-pkg-info.mk

export LIBICU_PACKAGENAME=$(shell apt-cache depends libicu-dev | grep --only-matching --extended-regexp 'libicu[0-9]+')

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

ifeq ($(DOTNET_80_OR_GREATER), false)
    export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
endif

ifeq ($(DEB_HOST_ARCH), arm64)
# 	-fstack-clash-protection is not implemented in arm64 clang,
# 	therefore stripping this flag away to avoid the error:
# 	clang: error: argument unused during compilation.
# 	See https://github.com/llvm/llvm-project/issues/40148
    export DEB_CFLAGS_MAINT_STRIP += -fstack-clash-protection
    export DEB_CXXFLAGS_MAINT_STRIP += -fstack-clash-protection

    UBUNTU_2310_OR_GREATER = $(shell . /etc/os-release && dpkg --compare-versions $${VERSION_ID} ge 23.10 && echo true || echo false)
ifeq ($(UBUNTU_2310_OR_GREATER), true)
#   On ARM64 Ubuntu 23.10 and higher the build will fail with the message
#   "Cannot find mkstemps nor mkstemp on this platform.", related to libunwind
#   and the branch-protection `pac-ret`. By default branch-protection `standard`
#   is set which is equivalent to `bti+pac-ret`.
#   By stripping branch-protection `standard` and appending branch-protection
#   `bti`, effectively only branch protection `pac-ret` gets stripped.
#   See also: https://github.com/canonical/dotnet-source-build/issues/7
    export DEB_CFLAGS_MAINT_STRIP += -mbranch-protection=standard
    export DEB_CXXFLAGS_MAINT_STRIP += -mbranch-protection=standard

    export DEB_CFLAGS_MAINT_APPEND += -mbranch-protection=bti
    export DEB_CXXFLAGS_MAINT_APPEND += -mbranch-protection=bti
endif
endif

ifeq ($(DOTNET_CONTAINS_BOOTSTRAPPING_SDK), true)
    DOTNET_BUILD_ARGS += --clean-while-building
    ifneq ($(filter $(DEB_HOST_ARCH),s390x ppc64el),)
        DOTNET_BUILD_ARGS += --with-sdk $(CURDIR)/dotnet
    endif
else
    DOTNET_PREVIOUS_BUILT_DIR = $(CURDIR)/previously-built-dotnet
    DOTNET_BUILD_ARGS += --with-sdk "$(DOTNET_PREVIOUS_BUILT_DIR)"

    ifeq ($(DOTNET_80_OR_GREATER), true)
        DOTNET_PREREQS_PACKAGES_ARCHIVE_DIR = $(CURDIR)/prereqs/packages/archive
    else
        DOTNET_PREREQS_PACKAGES_ARCHIVE_DIR = $(CURDIR)/packages/archive
    endif
endif

ifeq ($(DOTNET_80_OR_GREATER), true)
    DOTNET_BUILD_ARGS += --source-repository $(DOTNET_GIT_REPO)
    DOTNET_BUILD_ARGS += --source-version $(DOTNET_GIT_COMMIT)
endif

ifeq ($(DOTNET_90_OR_GREATER), true)
    DOTNET_BUILD_ARGS += --source-only
    DOTNET_RELEASE_ARTIFACTS_DIR = $(CURDIR)/artifacts/assets/Release

    ifeq ($(DOTNET_USE_SYSTEM_BROTLI), true)
        SYSTEM_LIBRARIES += +brotli
    endif
    ifeq ($(DOTNET_USE_SYSTEM_LIBUNWIND), true)
        SYSTEM_LIBRARIES += +libunwind
    endif
    ifeq ($(DOTNET_USE_SYSTEM_RAPIDJSON), true)
        SYSTEM_LIBRARIES += +rapidjson
    endif
    ifeq ($(DOTNET_USE_SYSTEM_ZLIB), true)
        SYSTEM_LIBRARIES += +zlib
    endif

#	The += operator adds text preceded by a space. Since the system libs list should
#	contain no space, we replace every space in the string with an empty character.
    space := $(shell printf " ")
    DOTNET_BUILD_ARGS += --with-system-libs $(subst $(space),,$(SYSTEM_LIBRARIES))

    ifeq ($(DOTNET_USE_MONO_RUNTIME), true)
        DOTNET_BUILD_ARGS += --use-mono-runtime
    endif
else
    DOTNET_RELEASE_ARTIFACTS_DIR = $(CURDIR)/artifacts/$(DOTNET_ARCH)/Release
endif

%:
	dh $@ --with bash-completion

override_dh_auto_build:
	printenv | sort
	vmstat --stats --unit MiB

#	If a library is being pulled in from the system, remove the bundled source for it
ifeq ($(DOTNET_USE_SYSTEM_BROTLI), true)
	rm --recursive --force $(CURDIR)/src/runtime/src/native/external/brotli
endif
ifeq ($(DOTNET_USE_SYSTEM_LIBUNWIND), true)
	rm --recursive --force $(CURDIR)/src/runtime/src/native/external/libunwind
endif
ifeq ($(DOTNET_USE_SYSTEM_RAPIDJSON), true)
	rm --recursive --force $(CURDIR)/src/runtime/src/native/external/rapidjson
endif
ifeq ($(DOTNET_USE_SYSTEM_ZLIB), true)
	rm --recursive --force $(CURDIR)/src/runtime/src/native/external/zlib
	rm --recursive --force $(CURDIR)/src/runtime/src/native/external/zlib-intel
	rm --recursive --force $(CURDIR)/src/runtime/src/native/external/zlib-ng
endif

ifeq ($(DOTNET_CONTAINS_BOOTSTRAPPING_SDK), false)
	mkdir --parents "$(DOTNET_PREREQS_PACKAGES_ARCHIVE_DIR)"
	
	DOTNET_SOURCE_BUILT_ARTIFACTS_TARBALL=($$(find "$(DOTNET_ROOT_DIR)/source-built-artifacts" -maxdepth 1 -name 'Private.SourceBuilt.Artifacts.$(DOTNET_MAJOR).$(DOTNET_MINOR).*.$(DOTNET_RUNTIME_ID).tar.gz')); \
	if [ "$${#DOTNET_SOURCE_BUILT_ARTIFACTS_TARBALL[@]}" -ne 1 ]; then \
		echo "None or more than one source built artifacts tarballs have been found: $${DOTNET_SOURCE_BUILT_ARTIFACTS_TARBALL[@]}"; \
		exit 1; \
	fi; \
	echo "source built artifacts tarball: $${DOTNET_SOURCE_BUILT_ARTIFACTS_TARBALL}"; \
	ln --symbolic \
		"$${DOTNET_SOURCE_BUILT_ARTIFACTS_TARBALL}" \
		"$(DOTNET_PREREQS_PACKAGES_ARCHIVE_DIR)/"
	
	cp --recursive --dereference --preserve=mode,ownership,timestamps \
	    "$(DOTNET_ROOT_DIR)" \
	    "$(DOTNET_PREVIOUS_BUILT_DIR)"
endif
	VERBOSE=1 ./build.sh $(DOTNET_BUILD_ARGS) \
	-- \
	/v:n \
	/p:SkipPortableRuntimeBuild=true \
	/p:LogVerbosity=n \
	/p:MinimalConsoleLogOutput=false \
	/p:ContinueOnPrebuiltBaselineError=true
	
ifeq ($(DOTNET_90_OR_GREATER), true)
	tree
endif

override_dh_auto_test:
	python3 ./debian/tests/build-time-tests/tests.py --verbose --purge-after

override_dh_install:
	install --mode=0755 --directory "$(DEST_DIR)$(DOTNET_ROOT_DIR)"
	install --mode=0755 --directory "$(DEST_DIR)$(DOTNET_SYSCONF_DIR)"
	ls "$(DOTNET_RELEASE_ARTIFACTS_DIR)"
	
	tar --extract \
	    --file "$(DOTNET_RELEASE_ARTIFACTS_DIR)"/dotnet-sdk-*-$(DOTNET_RUNTIME_ID).tar.gz \
	    --directory "$(DEST_DIR)$(DOTNET_ROOT_DIR)"
	
ifeq ($(DOTNET_80_OR_GREATER), true)
# 	Clean up unwanted PDB files in sdk tar.gz
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.pdb' -exec rm {} \;
	
# 	Extract debug symbols to their own directory for easy handling
	mkdir --parents "$(CURDIR)/artifacts/debug-symbols"
	tar --extract \
	    --file "$(DOTNET_RELEASE_ARTIFACTS_DIR)"/dotnet-symbols-sdk-*-$(DOTNET_RUNTIME_ID).tar.gz \
	    --directory "$(CURDIR)/artifacts/debug-symbols"
	ls "$(CURDIR)/artifacts/debug-symbols"
endif
	
#   See https://github.com/dotnet/source-build/issues/2579
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name 'testhost.x86' -delete
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name 'vstest.console' -delete

#   Fix executable permissions on files
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name 'apphost' -exec chmod +x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name 'lib*so' -exec chmod +x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name 'singlefilehost' -exec chmod +x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.a' -exec chmod -x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.dll' -exec chmod -x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.json' -exec chmod -x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.pdb' -exec chmod -x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.props' -exec chmod -x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.pubxml' -exec chmod -x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.targets' -exec chmod -x {} \;
	find "$(DEST_DIR)$(DOTNET_ROOT_DIR)" -type f -name '*.txt' -exec chmod -x {} \;
